Index: src/molecules.cpp
===================================================================
--- src/molecules.cpp	(revision 8c54a3b5f6bdf770309a91dff75fb62f47d91b6d)
+++ src/molecules.cpp	(revision 0dbddc24a89f547aa564634e7647f87ec8ce9700)
@@ -175,259 +171,259 @@
 bool molecule::AddHydrogenReplacementAtom(ofstream *out, bond *TopBond, atom *BottomOrigin, atom *TopOrigin, atom *TopReplacement, bond **BondList, int NumBond, bool IsAngstroem)
 {
-	double bondlength;	// bond length of the bond to be replaced/cut
-	double bondangle;	// bond angle of the bond to be replaced/cut
-	double BondRescale;	 // rescale value for the hydrogen bond length
-	bool AllWentWell = true;		// flag gathering the boolean return value of molecule::AddAtom and other functions, as return value on exit
-	bond *FirstBond = NULL, *SecondBond = NULL; // Other bonds in double bond case to determine "other" plane
-	atom *FirstOtherAtom = NULL, *SecondOtherAtom = NULL, *ThirdOtherAtom = NULL; // pointer to hydrogen atoms to be added
-	double b,l,d,f,g, alpha, factors[NDIM];		// hold temporary values in triple bond case for coordination determination
-	Vector Orthovector1, Orthovector2;	// temporary vectors in coordination construction
-	Vector InBondvector;		// vector in direction of *Bond
-	bond *Binder = NULL;
-	double *matrix;
-
-//	*out << Verbose(3) << "Begin of AddHydrogenReplacementAtom." << endl;
-	// create vector in direction of bond
-	InBondvector.CopyVector(&TopReplacement->x);
-	InBondvector.SubtractVector(&TopOrigin->x);
-	bondlength = InBondvector.Norm();
-
-	 // is greater than typical bond distance? Then we have to correct periodically
-	 // the problem is not the H being out of the box, but InBondvector have the wrong direction
-	 // due to TopReplacement or Origin being on the wrong side!
-	if (bondlength > BondDistance) {
-//		*out << Verbose(4) << "InBondvector is: ";
-//		InBondvector.Output(out);
-//		*out << endl;
-		Orthovector1.Zero();
-		for (int i=NDIM;i--;) {
-			l = TopReplacement->x.x[i] - TopOrigin->x.x[i];
-			if (fabs(l) > BondDistance) { // is component greater than bond distance
-				Orthovector1.x[i] = (l < 0) ? -1. : +1.;
-			} // (signs are correct, was tested!)
-		}
-		matrix = ReturnFullMatrixforSymmetric(cell_size);
-		Orthovector1.MatrixMultiplication(matrix);
-		InBondvector.SubtractVector(&Orthovector1); // subtract just the additional translation
-		Free((void **)&matrix, "molecule::AddHydrogenReplacementAtom: *matrix");
-		bondlength = InBondvector.Norm();
-//		*out << Verbose(4) << "Corrected InBondvector is now: ";
-//		InBondvector.Output(out);
-//		*out << endl;
-	} // periodic correction finished
-
-	InBondvector.Normalize();
-	// get typical bond length and store as scale factor for later
-	BondRescale = TopOrigin->type->HBondDistance[TopBond->BondDegree-1];
-	if (BondRescale == -1) {
-		cerr << Verbose(3) << "ERROR: There is no typical hydrogen bond distance in replacing bond (" << TopOrigin->Name << "<->" << TopReplacement->Name << ") of degree " << TopBond->BondDegree << "!" << endl;
-		return false;
-		BondRescale = bondlength;
-	} else {
-		if (!IsAngstroem)
-			BondRescale /= (1.*AtomicLengthToAngstroem);
-	}
-
-	// discern single, double and triple bonds
-	switch(TopBond->BondDegree) {
-		case 1:
-			FirstOtherAtom = new atom();		// new atom
-			FirstOtherAtom->type = elemente->FindElement(1);	// element is Hydrogen
-			FirstOtherAtom->v.CopyVector(&TopReplacement->v); // copy velocity
-			FirstOtherAtom->FixedIon = TopReplacement->FixedIon;
-			if (TopReplacement->type->Z == 1) { // neither rescale nor replace if it's already hydrogen
-				FirstOtherAtom->father = TopReplacement;
-				BondRescale = bondlength;
-			} else {
-				FirstOtherAtom->father = NULL;	// if we replace hydrogen, we mark it as our father, otherwise we are just an added hydrogen with no father
-			}
-			InBondvector.Scale(&BondRescale);	 // rescale the distance vector to Hydrogen bond length
-			FirstOtherAtom->x.CopyVector(&TopOrigin->x); // set coordination to origin ...
-			FirstOtherAtom->x.AddVector(&InBondvector);	// ... and add distance vector to replacement atom
-			AllWentWell = AllWentWell && AddAtom(FirstOtherAtom);
-//			*out << Verbose(4) << "Added " << *FirstOtherAtom << " at: ";
-//			FirstOtherAtom->x.Output(out);
-//			*out << endl;
-			Binder = AddBond(BottomOrigin, FirstOtherAtom, 1);
-			Binder->Cyclic = false;
-			Binder->Type = TreeEdge;
-			break;
-		case 2:
-			// determine two other bonds (warning if there are more than two other) plus valence sanity check
-			for (int i=0;i<NumBond;i++) {
-				if (BondList[i] != TopBond) {
-					if (FirstBond == NULL) {
-						FirstBond = BondList[i];
-						FirstOtherAtom = BondList[i]->GetOtherAtom(TopOrigin);
-					} else if (SecondBond == NULL) {
-						SecondBond = BondList[i];
-						SecondOtherAtom = BondList[i]->GetOtherAtom(TopOrigin);
-					} else {
-						*out << Verbose(3) << "WARNING: Detected more than four bonds for atom " << TopOrigin->Name;
-					}
-				}
-			}
-			if (SecondOtherAtom == NULL) {	// then we have an atom with valence four, but only 3 bonds: one to replace and one which is TopBond (third is FirstBond)
-				SecondBond = TopBond;
-				SecondOtherAtom = TopReplacement;
-			}
-			if (FirstOtherAtom != NULL) { // then we just have this double bond and the plane does not matter at all
-//				*out << Verbose(3) << "Regarding the double bond (" << TopOrigin->Name << "<->" << TopReplacement->Name << ") to be constructed: Taking " << FirstOtherAtom->Name << " and " << SecondOtherAtom->Name << " along with " << TopOrigin->Name << " to determine orthogonal plane." << endl;
-
-				// determine the plane of these two with the *origin
-				AllWentWell = AllWentWell && Orthovector1.MakeNormalVector(&TopOrigin->x, &FirstOtherAtom->x, &SecondOtherAtom->x);
-			} else {
-				Orthovector1.GetOneNormalVector(&InBondvector);
-			}
-			//*out << Verbose(3)<< "Orthovector1: ";
-			//Orthovector1.Output(out);
-			//*out << endl;
-			// orthogonal vector and bond vector between origin and replacement form the new plane
-			Orthovector1.MakeNormalVector(&InBondvector);
-			Orthovector1.Normalize();
-			//*out << Verbose(3) << "ReScaleCheck: " << Orthovector1.Norm() << " and " << InBondvector.Norm() << "." << endl;
-
-			// create the two Hydrogens ...
-			FirstOtherAtom = new atom();
-			SecondOtherAtom = new atom();
-			FirstOtherAtom->type = elemente->FindElement(1);
-			SecondOtherAtom->type = elemente->FindElement(1);
-			FirstOtherAtom->v.CopyVector(&TopReplacement->v); // copy velocity
-			FirstOtherAtom->FixedIon = TopReplacement->FixedIon;
-			SecondOtherAtom->v.CopyVector(&TopReplacement->v); // copy velocity
-			SecondOtherAtom->FixedIon = TopReplacement->FixedIon;
-			FirstOtherAtom->father = NULL;	// we are just an added hydrogen with no father
-			SecondOtherAtom->father = NULL;	//	we are just an added hydrogen with no father
-			bondangle = TopOrigin->type->HBondAngle[1];
-			if (bondangle == -1) {
-				*out << Verbose(3) << "ERROR: There is no typical hydrogen bond angle in replacing bond (" << TopOrigin->Name << "<->" << TopReplacement->Name << ") of degree " << TopBond->BondDegree << "!" << endl;
-				return false;
-				bondangle = 0;
-			}
-			bondangle *= M_PI/180./2.;
-//			*out << Verbose(3) << "ReScaleCheck: InBondvector ";
-//			InBondvector.Output(out);
-//			*out << endl;
-//			*out << Verbose(3) << "ReScaleCheck: Orthovector ";
-//			Orthovector1.Output(out);
-//			*out << endl;
-//			*out << Verbose(3) << "Half the bond angle is " << bondangle << ", sin and cos of it: " << sin(bondangle) << ", " << cos(bondangle) << endl;
-			FirstOtherAtom->x.Zero();
-			SecondOtherAtom->x.Zero();
-			for(int i=NDIM;i--;) { // rotate by half the bond angle in both directions (InBondvector is bondangle = 0 direction)
-				FirstOtherAtom->x.x[i] = InBondvector.x[i] * cos(bondangle) + Orthovector1.x[i] * (sin(bondangle));
-				SecondOtherAtom->x.x[i] = InBondvector.x[i] * cos(bondangle) + Orthovector1.x[i] * (-sin(bondangle));
-			}
-			FirstOtherAtom->x.Scale(&BondRescale);	// rescale by correct BondDistance
-			SecondOtherAtom->x.Scale(&BondRescale);
-			//*out << Verbose(3) << "ReScaleCheck: " << FirstOtherAtom->x.Norm() << " and " << SecondOtherAtom->x.Norm() << "." << endl;
-			for(int i=NDIM;i--;) { // and make relative to origin atom
-				FirstOtherAtom->x.x[i] += TopOrigin->x.x[i];
-				SecondOtherAtom->x.x[i] += TopOrigin->x.x[i];
-			}
-			// ... and add to molecule
-			AllWentWell = AllWentWell && AddAtom(FirstOtherAtom);
-			AllWentWell = AllWentWell && AddAtom(SecondOtherAtom);
-//			*out << Verbose(4) << "Added " << *FirstOtherAtom << " at: ";
-//			FirstOtherAtom->x.Output(out);
-//			*out << endl;
-//			*out << Verbose(4) << "Added " << *SecondOtherAtom << " at: ";
-//			SecondOtherAtom->x.Output(out);
-//			*out << endl;
-			Binder = AddBond(BottomOrigin, FirstOtherAtom, 1);
-			Binder->Cyclic = false;
-			Binder->Type = TreeEdge;
-			Binder = AddBond(BottomOrigin, SecondOtherAtom, 1);
-			Binder->Cyclic = false;
-			Binder->Type = TreeEdge;
-			break;
-		case 3:
-			// take the "usual" tetraoidal angle and add the three Hydrogen in direction of the bond (height of the tetraoid)
-			FirstOtherAtom = new atom();
-			SecondOtherAtom = new atom();
-			ThirdOtherAtom = new atom();
-			FirstOtherAtom->type = elemente->FindElement(1);
-			SecondOtherAtom->type = elemente->FindElement(1);
-			ThirdOtherAtom->type = elemente->FindElement(1);
-			FirstOtherAtom->v.CopyVector(&TopReplacement->v); // copy velocity
-			FirstOtherAtom->FixedIon = TopReplacement->FixedIon;
-			SecondOtherAtom->v.CopyVector(&TopReplacement->v); // copy velocity
-			SecondOtherAtom->FixedIon = TopReplacement->FixedIon;
-			ThirdOtherAtom->v.CopyVector(&TopReplacement->v); // copy velocity
-			ThirdOtherAtom->FixedIon = TopReplacement->FixedIon;
-			FirstOtherAtom->father = NULL;	//	we are just an added hydrogen with no father
-			SecondOtherAtom->father = NULL;	//	we are just an added hydrogen with no father
-			ThirdOtherAtom->father = NULL;	//	we are just an added hydrogen with no father
-
-			// we need to vectors orthonormal the InBondvector
-			AllWentWell = AllWentWell && Orthovector1.GetOneNormalVector(&InBondvector);
-//			*out << Verbose(3) << "Orthovector1: ";
-//			Orthovector1.Output(out);
-//			*out << endl;
-			AllWentWell = AllWentWell && Orthovector2.MakeNormalVector(&InBondvector, &Orthovector1);
-//			*out << Verbose(3) << "Orthovector2: ";
-//			Orthovector2.Output(out);
-//			*out << endl;
-
-			// create correct coordination for the three atoms
-			alpha = (TopOrigin->type->HBondAngle[2])/180.*M_PI/2.;	// retrieve triple bond angle from database
-			l = BondRescale;				// desired bond length
-			b = 2.*l*sin(alpha);		// base length of isosceles triangle
-			d = l*sqrt(cos(alpha)*cos(alpha) - sin(alpha)*sin(alpha)/3.);	 // length for InBondvector
-			f = b/sqrt(3.);	 // length for Orthvector1
-			g = b/2.;				 // length for Orthvector2
-//			*out << Verbose(3) << "Bond length and half-angle: " << l << ", " << alpha << "\t (b,d,f,g) = " << b << ", " << d << ", " << f << ", " << g << ", " << endl;
-//			*out << Verbose(3) << "The three Bond lengths: " << sqrt(d*d+f*f) << ", " << sqrt(d*d+(-0.5*f)*(-0.5*f)+g*g) << ", "	<< sqrt(d*d+(-0.5*f)*(-0.5*f)+g*g) << endl;
-			factors[0] = d;
-			factors[1] = f;
-			factors[2] = 0.;
-			FirstOtherAtom->x.LinearCombinationOfVectors(&InBondvector, &Orthovector1, &Orthovector2, factors);
-			factors[1] = -0.5*f;
-			factors[2] = g;
-			SecondOtherAtom->x.LinearCombinationOfVectors(&InBondvector, &Orthovector1, &Orthovector2, factors);
-			factors[2] = -g;
-			ThirdOtherAtom->x.LinearCombinationOfVectors(&InBondvector, &Orthovector1, &Orthovector2, factors);
-
-			// rescale each to correct BondDistance
-//			FirstOtherAtom->x.Scale(&BondRescale);
-//			SecondOtherAtom->x.Scale(&BondRescale);
-//			ThirdOtherAtom->x.Scale(&BondRescale);
-
-			// and relative to *origin atom
-			FirstOtherAtom->x.AddVector(&TopOrigin->x);
-			SecondOtherAtom->x.AddVector(&TopOrigin->x);
-			ThirdOtherAtom->x.AddVector(&TopOrigin->x);
-
-			// ... and add to molecule
-			AllWentWell = AllWentWell && AddAtom(FirstOtherAtom);
-			AllWentWell = AllWentWell && AddAtom(SecondOtherAtom);
-			AllWentWell = AllWentWell && AddAtom(ThirdOtherAtom);
-//			*out << Verbose(4) << "Added " << *FirstOtherAtom << " at: ";
-//			FirstOtherAtom->x.Output(out);
-//			*out << endl;
-//			*out << Verbose(4) << "Added " << *SecondOtherAtom << " at: ";
-//			SecondOtherAtom->x.Output(out);
-//			*out << endl;
-//			*out << Verbose(4) << "Added " << *ThirdOtherAtom << " at: ";
-//			ThirdOtherAtom->x.Output(out);
-//			*out << endl;
-			Binder = AddBond(BottomOrigin, FirstOtherAtom, 1);
-			Binder->Cyclic = false;
-			Binder->Type = TreeEdge;
-			Binder = AddBond(BottomOrigin, SecondOtherAtom, 1);
-			Binder->Cyclic = false;
-			Binder->Type = TreeEdge;
-			Binder = AddBond(BottomOrigin, ThirdOtherAtom, 1);
-			Binder->Cyclic = false;
-			Binder->Type = TreeEdge;
-			break;
-		default:
-			cerr << "ERROR: BondDegree does not state single, double or triple bond!" << endl;
-			AllWentWell = false;
-			break;
-	}
-
-//	*out << Verbose(3) << "End of AddHydrogenReplacementAtom." << endl;
-	return AllWentWell;
+  double bondlength;  // bond length of the bond to be replaced/cut
+  double bondangle;  // bond angle of the bond to be replaced/cut
+  double BondRescale;   // rescale value for the hydrogen bond length
+  bool AllWentWell = true;    // flag gathering the boolean return value of molecule::AddAtom and other functions, as return value on exit
+  bond *FirstBond = NULL, *SecondBond = NULL; // Other bonds in double bond case to determine "other" plane
+  atom *FirstOtherAtom = NULL, *SecondOtherAtom = NULL, *ThirdOtherAtom = NULL; // pointer to hydrogen atoms to be added
+  double b,l,d,f,g, alpha, factors[NDIM];    // hold temporary values in triple bond case for coordination determination
+  Vector Orthovector1, Orthovector2;  // temporary vectors in coordination construction
+  Vector InBondvector;    // vector in direction of *Bond
+  bond *Binder = NULL;
+  double *matrix;
+
+//  *out << Verbose(3) << "Begin of AddHydrogenReplacementAtom." << endl;
+  // create vector in direction of bond
+  InBondvector.CopyVector(&TopReplacement->x);
+  InBondvector.SubtractVector(&TopOrigin->x);
+  bondlength = InBondvector.Norm();
+
+   // is greater than typical bond distance? Then we have to correct periodically
+   // the problem is not the H being out of the box, but InBondvector have the wrong direction
+   // due to TopReplacement or Origin being on the wrong side!
+  if (bondlength > BondDistance) {
+//    *out << Verbose(4) << "InBondvector is: ";
+//    InBondvector.Output(out);
+//    *out << endl;
+    Orthovector1.Zero();
+    for (int i=NDIM;i--;) {
+      l = TopReplacement->x.x[i] - TopOrigin->x.x[i];
+      if (fabs(l) > BondDistance) { // is component greater than bond distance
+        Orthovector1.x[i] = (l < 0) ? -1. : +1.;
+      } // (signs are correct, was tested!)
+    }
+    matrix = ReturnFullMatrixforSymmetric(cell_size);
+    Orthovector1.MatrixMultiplication(matrix);
+    InBondvector.SubtractVector(&Orthovector1); // subtract just the additional translation
+    Free((void **)&matrix, "molecule::AddHydrogenReplacementAtom: *matrix");
+    bondlength = InBondvector.Norm();
+//    *out << Verbose(4) << "Corrected InBondvector is now: ";
+//    InBondvector.Output(out);
+//    *out << endl;
+  } // periodic correction finished
+
+  InBondvector.Normalize();
+  // get typical bond length and store as scale factor for later
+  BondRescale = TopOrigin->type->HBondDistance[TopBond->BondDegree-1];
+  if (BondRescale == -1) {
+    cerr << Verbose(3) << "ERROR: There is no typical hydrogen bond distance in replacing bond (" << TopOrigin->Name << "<->" << TopReplacement->Name << ") of degree " << TopBond->BondDegree << "!" << endl;
+    return false;
+    BondRescale = bondlength;
+  } else {
+    if (!IsAngstroem)
+      BondRescale /= (1.*AtomicLengthToAngstroem);
+  }
+
+  // discern single, double and triple bonds
+  switch(TopBond->BondDegree) {
+    case 1:
+      FirstOtherAtom = new atom();    // new atom
+      FirstOtherAtom->type = elemente->FindElement(1);  // element is Hydrogen
+      FirstOtherAtom->v.CopyVector(&TopReplacement->v); // copy velocity
+      FirstOtherAtom->FixedIon = TopReplacement->FixedIon;
+      if (TopReplacement->type->Z == 1) { // neither rescale nor replace if it's already hydrogen
+        FirstOtherAtom->father = TopReplacement;
+        BondRescale = bondlength;
+      } else {
+        FirstOtherAtom->father = NULL;  // if we replace hydrogen, we mark it as our father, otherwise we are just an added hydrogen with no father
+      }
+      InBondvector.Scale(&BondRescale);   // rescale the distance vector to Hydrogen bond length
+      FirstOtherAtom->x.CopyVector(&TopOrigin->x); // set coordination to origin ...
+      FirstOtherAtom->x.AddVector(&InBondvector);  // ... and add distance vector to replacement atom
+      AllWentWell = AllWentWell && AddAtom(FirstOtherAtom);
+//      *out << Verbose(4) << "Added " << *FirstOtherAtom << " at: ";
+//      FirstOtherAtom->x.Output(out);
+//      *out << endl;
+      Binder = AddBond(BottomOrigin, FirstOtherAtom, 1);
+      Binder->Cyclic = false;
+      Binder->Type = TreeEdge;
+      break;
+    case 2:
+      // determine two other bonds (warning if there are more than two other) plus valence sanity check
+      for (int i=0;i<NumBond;i++) {
+        if (BondList[i] != TopBond) {
+          if (FirstBond == NULL) {
+            FirstBond = BondList[i];
+            FirstOtherAtom = BondList[i]->GetOtherAtom(TopOrigin);
+          } else if (SecondBond == NULL) {
+            SecondBond = BondList[i];
+            SecondOtherAtom = BondList[i]->GetOtherAtom(TopOrigin);
+          } else {
+            *out << Verbose(3) << "WARNING: Detected more than four bonds for atom " << TopOrigin->Name;
+          }
+        }
+      }
+      if (SecondOtherAtom == NULL) {  // then we have an atom with valence four, but only 3 bonds: one to replace and one which is TopBond (third is FirstBond)
+        SecondBond = TopBond;
+        SecondOtherAtom = TopReplacement;
+      }
+      if (FirstOtherAtom != NULL) { // then we just have this double bond and the plane does not matter at all
+//        *out << Verbose(3) << "Regarding the double bond (" << TopOrigin->Name << "<->" << TopReplacement->Name << ") to be constructed: Taking " << FirstOtherAtom->Name << " and " << SecondOtherAtom->Name << " along with " << TopOrigin->Name << " to determine orthogonal plane." << endl;
+
+        // determine the plane of these two with the *origin
+        AllWentWell = AllWentWell && Orthovector1.MakeNormalVector(&TopOrigin->x, &FirstOtherAtom->x, &SecondOtherAtom->x);
+      } else {
+        Orthovector1.GetOneNormalVector(&InBondvector);
+      }
+      //*out << Verbose(3)<< "Orthovector1: ";
+      //Orthovector1.Output(out);
+      //*out << endl;
+      // orthogonal vector and bond vector between origin and replacement form the new plane
+      Orthovector1.MakeNormalVector(&InBondvector);
+      Orthovector1.Normalize();
+      //*out << Verbose(3) << "ReScaleCheck: " << Orthovector1.Norm() << " and " << InBondvector.Norm() << "." << endl;
+
+      // create the two Hydrogens ...
+      FirstOtherAtom = new atom();
+      SecondOtherAtom = new atom();
+      FirstOtherAtom->type = elemente->FindElement(1);
+      SecondOtherAtom->type = elemente->FindElement(1);
+      FirstOtherAtom->v.CopyVector(&TopReplacement->v); // copy velocity
+      FirstOtherAtom->FixedIon = TopReplacement->FixedIon;
+      SecondOtherAtom->v.CopyVector(&TopReplacement->v); // copy velocity
+      SecondOtherAtom->FixedIon = TopReplacement->FixedIon;
+      FirstOtherAtom->father = NULL;  // we are just an added hydrogen with no father
+      SecondOtherAtom->father = NULL;  //  we are just an added hydrogen with no father
+      bondangle = TopOrigin->type->HBondAngle[1];
+      if (bondangle == -1) {
+        *out << Verbose(3) << "ERROR: There is no typical hydrogen bond angle in replacing bond (" << TopOrigin->Name << "<->" << TopReplacement->Name << ") of degree " << TopBond->BondDegree << "!" << endl;
+        return false;
+        bondangle = 0;
+      }
+      bondangle *= M_PI/180./2.;
+//      *out << Verbose(3) << "ReScaleCheck: InBondvector ";
+//      InBondvector.Output(out);
+//      *out << endl;
+//      *out << Verbose(3) << "ReScaleCheck: Orthovector ";
+//      Orthovector1.Output(out);
+//      *out << endl;
+//      *out << Verbose(3) << "Half the bond angle is " << bondangle << ", sin and cos of it: " << sin(bondangle) << ", " << cos(bondangle) << endl;
+      FirstOtherAtom->x.Zero();
+      SecondOtherAtom->x.Zero();
+      for(int i=NDIM;i--;) { // rotate by half the bond angle in both directions (InBondvector is bondangle = 0 direction)
+        FirstOtherAtom->x.x[i] = InBondvector.x[i] * cos(bondangle) + Orthovector1.x[i] * (sin(bondangle));
+        SecondOtherAtom->x.x[i] = InBondvector.x[i] * cos(bondangle) + Orthovector1.x[i] * (-sin(bondangle));
+      }
+      FirstOtherAtom->x.Scale(&BondRescale);  // rescale by correct BondDistance
+      SecondOtherAtom->x.Scale(&BondRescale);
+      //*out << Verbose(3) << "ReScaleCheck: " << FirstOtherAtom->x.Norm() << " and " << SecondOtherAtom->x.Norm() << "." << endl;
+      for(int i=NDIM;i--;) { // and make relative to origin atom
+        FirstOtherAtom->x.x[i] += TopOrigin->x.x[i];
+        SecondOtherAtom->x.x[i] += TopOrigin->x.x[i];
+      }
+      // ... and add to molecule
+      AllWentWell = AllWentWell && AddAtom(FirstOtherAtom);
+      AllWentWell = AllWentWell && AddAtom(SecondOtherAtom);
+//      *out << Verbose(4) << "Added " << *FirstOtherAtom << " at: ";
+//      FirstOtherAtom->x.Output(out);
+//      *out << endl;
+//      *out << Verbose(4) << "Added " << *SecondOtherAtom << " at: ";
+//      SecondOtherAtom->x.Output(out);
+//      *out << endl;
+      Binder = AddBond(BottomOrigin, FirstOtherAtom, 1);
+      Binder->Cyclic = false;
+      Binder->Type = TreeEdge;
+      Binder = AddBond(BottomOrigin, SecondOtherAtom, 1);
+      Binder->Cyclic = false;
+      Binder->Type = TreeEdge;
+      break;
+    case 3:
+      // take the "usual" tetraoidal angle and add the three Hydrogen in direction of the bond (height of the tetraoid)
+      FirstOtherAtom = new atom();
+      SecondOtherAtom = new atom();
+      ThirdOtherAtom = new atom();
+      FirstOtherAtom->type = elemente->FindElement(1);
+      SecondOtherAtom->type = elemente->FindElement(1);
+      ThirdOtherAtom->type = elemente->FindElement(1);
+      FirstOtherAtom->v.CopyVector(&TopReplacement->v); // copy velocity
+      FirstOtherAtom->FixedIon = TopReplacement->FixedIon;
+      SecondOtherAtom->v.CopyVector(&TopReplacement->v); // copy velocity
+      SecondOtherAtom->FixedIon = TopReplacement->FixedIon;
+      ThirdOtherAtom->v.CopyVector(&TopReplacement->v); // copy velocity
+      ThirdOtherAtom->FixedIon = TopReplacement->FixedIon;
+      FirstOtherAtom->father = NULL;  //  we are just an added hydrogen with no father
+      SecondOtherAtom->father = NULL;  //  we are just an added hydrogen with no father
+      ThirdOtherAtom->father = NULL;  //  we are just an added hydrogen with no father
+
+      // we need to vectors orthonormal the InBondvector
+      AllWentWell = AllWentWell && Orthovector1.GetOneNormalVector(&InBondvector);
+//      *out << Verbose(3) << "Orthovector1: ";
+//      Orthovector1.Output(out);
+//      *out << endl;
+      AllWentWell = AllWentWell && Orthovector2.MakeNormalVector(&InBondvector, &Orthovector1);
+//      *out << Verbose(3) << "Orthovector2: ";
+//      Orthovector2.Output(out);
+//      *out << endl;
+
+      // create correct coordination for the three atoms
+      alpha = (TopOrigin->type->HBondAngle[2])/180.*M_PI/2.;  // retrieve triple bond angle from database
+      l = BondRescale;        // desired bond length
+      b = 2.*l*sin(alpha);    // base length of isosceles triangle
+      d = l*sqrt(cos(alpha)*cos(alpha) - sin(alpha)*sin(alpha)/3.);   // length for InBondvector
+      f = b/sqrt(3.);   // length for Orthvector1
+      g = b/2.;         // length for Orthvector2
+//      *out << Verbose(3) << "Bond length and half-angle: " << l << ", " << alpha << "\t (b,d,f,g) = " << b << ", " << d << ", " << f << ", " << g << ", " << endl;
+//      *out << Verbose(3) << "The three Bond lengths: " << sqrt(d*d+f*f) << ", " << sqrt(d*d+(-0.5*f)*(-0.5*f)+g*g) << ", "  << sqrt(d*d+(-0.5*f)*(-0.5*f)+g*g) << endl;
+      factors[0] = d;
+      factors[1] = f;
+      factors[2] = 0.;
+      FirstOtherAtom->x.LinearCombinationOfVectors(&InBondvector, &Orthovector1, &Orthovector2, factors);
+      factors[1] = -0.5*f;
+      factors[2] = g;
+      SecondOtherAtom->x.LinearCombinationOfVectors(&InBondvector, &Orthovector1, &Orthovector2, factors);
+      factors[2] = -g;
+      ThirdOtherAtom->x.LinearCombinationOfVectors(&InBondvector, &Orthovector1, &Orthovector2, factors);
+
+      // rescale each to correct BondDistance
+//      FirstOtherAtom->x.Scale(&BondRescale);
+//      SecondOtherAtom->x.Scale(&BondRescale);
+//      ThirdOtherAtom->x.Scale(&BondRescale);
+
+      // and relative to *origin atom
+      FirstOtherAtom->x.AddVector(&TopOrigin->x);
+      SecondOtherAtom->x.AddVector(&TopOrigin->x);
+      ThirdOtherAtom->x.AddVector(&TopOrigin->x);
+
+      // ... and add to molecule
+      AllWentWell = AllWentWell && AddAtom(FirstOtherAtom);
+      AllWentWell = AllWentWell && AddAtom(SecondOtherAtom);
+      AllWentWell = AllWentWell && AddAtom(ThirdOtherAtom);
+//      *out << Verbose(4) << "Added " << *FirstOtherAtom << " at: ";
+//      FirstOtherAtom->x.Output(out);
+//      *out << endl;
+//      *out << Verbose(4) << "Added " << *SecondOtherAtom << " at: ";
+//      SecondOtherAtom->x.Output(out);
+//      *out << endl;
+//      *out << Verbose(4) << "Added " << *ThirdOtherAtom << " at: ";
+//      ThirdOtherAtom->x.Output(out);
+//      *out << endl;
+      Binder = AddBond(BottomOrigin, FirstOtherAtom, 1);
+      Binder->Cyclic = false;
+      Binder->Type = TreeEdge;
+      Binder = AddBond(BottomOrigin, SecondOtherAtom, 1);
+      Binder->Cyclic = false;
+      Binder->Type = TreeEdge;
+      Binder = AddBond(BottomOrigin, ThirdOtherAtom, 1);
+      Binder->Cyclic = false;
+      Binder->Type = TreeEdge;
+      break;
+    default:
+      cerr << "ERROR: BondDegree does not state single, double or triple bond!" << endl;
+      AllWentWell = false;
+      break;
+  }
+
+//  *out << Verbose(3) << "End of AddHydrogenReplacementAtom." << endl;
+  return AllWentWell;
 };
 
@@ -439,58 +435,58 @@
 bool molecule::AddXYZFile(string filename)
 {
-	istringstream *input = NULL;
-	int NumberOfAtoms = 0; // atom number in xyz read
-	int i, j; // loop variables
-	atom *Walker = NULL;	// pointer to added atom
-	char shorthand[3];	// shorthand for atom name
-	ifstream xyzfile;	 // xyz file
-	string line;		// currently parsed line
-	double x[3];		// atom coordinates
-
-	xyzfile.open(filename.c_str());
-	if (!xyzfile)
-		return false;
-
-	getline(xyzfile,line,'\n'); // Read numer of atoms in file
-	input = new istringstream(line);
-	*input >> NumberOfAtoms;
-	cout << Verbose(0) << "Parsing " << NumberOfAtoms << " atoms in file." << endl;
-	getline(xyzfile,line,'\n'); // Read comment
-	cout << Verbose(1) << "Comment: " << line << endl;
-
-	if (MDSteps == 0) // no atoms yet present
-		MDSteps++;
-	for(i=0;i<NumberOfAtoms;i++){
-		Walker = new atom;
-		getline(xyzfile,line,'\n');
-		istringstream *item = new istringstream(line);
-		//istringstream input(line);
-		//cout << Verbose(1) << "Reading: " << line << endl;
-		*item >> shorthand;
-		*item >> x[0];
-		*item >> x[1];
-		*item >> x[2];
-		Walker->type = elemente->FindElement(shorthand);
-		if (Walker->type == NULL) {
-			cerr << "Could not parse the element at line: '" << line << "', setting to H.";
-			Walker->type = elemente->FindElement(1);
-		}
-		if (Trajectories[Walker].R.size() <= (unsigned int)MDSteps) {
-			Trajectories[Walker].R.resize(MDSteps+10);
-			Trajectories[Walker].U.resize(MDSteps+10);
-			Trajectories[Walker].F.resize(MDSteps+10);
-		}
-		for(j=NDIM;j--;) {
-			Walker->x.x[j] = x[j];
-			Trajectories[Walker].R.at(MDSteps-1).x[j] = x[j];
-			Trajectories[Walker].U.at(MDSteps-1).x[j] = 0;
-			Trajectories[Walker].F.at(MDSteps-1).x[j] = 0;
-		}
-		AddAtom(Walker);	// add to molecule
-		delete(item);
-	}
-	xyzfile.close();
-	delete(input);
-	return true;
+  istringstream *input = NULL;
+  int NumberOfAtoms = 0; // atom number in xyz read
+  int i, j; // loop variables
+  atom *Walker = NULL;  // pointer to added atom
+  char shorthand[3];  // shorthand for atom name
+  ifstream xyzfile;   // xyz file
+  string line;    // currently parsed line
+  double x[3];    // atom coordinates
+
+  xyzfile.open(filename.c_str());
+  if (!xyzfile)
+    return false;
+
+  getline(xyzfile,line,'\n'); // Read numer of atoms in file
+  input = new istringstream(line);
+  *input >> NumberOfAtoms;
+  cout << Verbose(0) << "Parsing " << NumberOfAtoms << " atoms in file." << endl;
+  getline(xyzfile,line,'\n'); // Read comment
+  cout << Verbose(1) << "Comment: " << line << endl;
+
+  if (MDSteps == 0) // no atoms yet present
+    MDSteps++;
+  for(i=0;i<NumberOfAtoms;i++){
+    Walker = new atom;
+    getline(xyzfile,line,'\n');
+    istringstream *item = new istringstream(line);
+    //istringstream input(line);
+    //cout << Verbose(1) << "Reading: " << line << endl;
+    *item >> shorthand;
+    *item >> x[0];
+    *item >> x[1];
+    *item >> x[2];
+    Walker->type = elemente->FindElement(shorthand);
+    if (Walker->type == NULL) {
+      cerr << "Could not parse the element at line: '" << line << "', setting to H.";
+      Walker->type = elemente->FindElement(1);
+    }
+    if (Trajectories[Walker].R.size() <= (unsigned int)MDSteps) {
+      Trajectories[Walker].R.resize(MDSteps+10);
+      Trajectories[Walker].U.resize(MDSteps+10);
+      Trajectories[Walker].F.resize(MDSteps+10);
+    }
+    for(j=NDIM;j--;) {
+      Walker->x.x[j] = x[j];
+      Trajectories[Walker].R.at(MDSteps-1).x[j] = x[j];
+      Trajectories[Walker].U.at(MDSteps-1).x[j] = 0;
+      Trajectories[Walker].F.at(MDSteps-1).x[j] = 0;
+    }
+    AddAtom(Walker);  // add to molecule
+    delete(item);
+  }
+  xyzfile.close();
+  delete(input);
+  return true;
 };
 
